searchNodes=[{"type":"module","title":"Lacca","doc":"","ref":"Lacca.html"},{"type":"function","title":"Lacca.alive?/1","doc":"Returns true if the inferior process is alive, otherwise returns false .","ref":"Lacca.html#alive?/1"},{"type":"function","title":"Lacca.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Lacca.html#child_spec/1"},{"type":"function","title":"Lacca.kill/1","doc":"Attempts to terminate the process immediately. Caller should expect that the process will not be gracefully terminated; similarly to calling SIGKILL on a POSIX operating system.","ref":"Lacca.html#kill/1"},{"type":"function","title":"Lacca.read_stderr/1","doc":"Returns {:ok, binary} which includes any data received from the child's stderr file descriptor. Note that the internal buffer is then cleared, such that subsequent reads will not return this same data again.","ref":"Lacca.html#read_stderr/1"},{"type":"function","title":"Lacca.read_stdout/1","doc":"Returns {:ok, binary} which includes any data received from the child's stdout file descriptor. Note that the internal buffer is then cleared, such that subsequent reads will not return this same data again.","ref":"Lacca.html#read_stdout/1"},{"type":"function","title":"Lacca.start/2","doc":"Starts the Lacca client without linking it to the caller's process. See start_link/2 for more information.","ref":"Lacca.html#start/2"},{"type":"function","title":"Lacca.start_link/2","doc":"Starts a Lacca client process which will run the executable located at exec_path with the specified command line arguments. The returned handle, of the form {:ok, pid} . The pid represents the lacca client, which communicates w/ a resin daemon via an external Port . The program at exec_path is supervised by this resin daemon, and is referred to as the inferior process. Note that stdout and stderr from the process are captured inside StringIO buffers internally. This data will remain in-memory until this server is either stopped, or the buffers are flushed using the respective API functions: read_stdout/1 and read_stderr/1 . Errors This method will raise ArgumentError if the resin daemon cannot be found on your system's executable PATH . The configuration key located at :resin, :daemon_path can be used to force this process to run the daemon from a non-standard location.","ref":"Lacca.html#start_link/2"},{"type":"function","title":"Lacca.stop/1","doc":"Shuts down the Lacca client process and closes the underlying resin port. Note that resin will not ask the child process to terminate when shutting down. Calling this, without calling kill/1 et al. first, is essentially the same as just closing the stdin of the inferior process. In the case that the inferior process does not exit upon reading EOF from stdin it will continue running unsupervised in the background. If you need to guarantee that the inferior process does not continue running: you must call kill/1 , or similar, and wait for alive?/1 to return false before stopping the Lacca client.","ref":"Lacca.html#stop/1"},{"type":"function","title":"Lacca.write_stdin/2","doc":"Returns :ok once the data has been sent to the underlying resin daemon. Note that this function returns immediately after having sent the packet to the daemon, no guarantees as to the delivery to the child process are afforded. (i.e: the child may have closed its stdin prematurely, the child may have exited in the interim, it may be deadlocked and not processing stdin, etc.)","ref":"Lacca.html#write_stdin/2"},{"type":"module","title":"Lacca.Protocol","doc":"This module provides helper functions for communicating with external processes which implement the shellac protocol. The wire format of the protocol follows: u16 packet length (i.e: read next n bytes) u8 packet flags [u8,...] packet payload (MsgPack encoded) NOTE: if the high bit (0x80) of the packet flags are set this message is incomplete and the payload must be buffered by the receiver.","ref":"Lacca.Protocol.html"},{"type":"module","title":"Lacca.Protocol.BinUtils","doc":"A collection of useful transformations when working w/ the binary portions of this protocol.","ref":"Lacca.Protocol.BinUtils.html"},{"type":"function","title":"Lacca.Protocol.BinUtils.chunk_binary/2","doc":"Splits a large binary into a list of smaller chunk_size binaries.","ref":"Lacca.Protocol.BinUtils.html#chunk_binary/2"},{"type":"module","title":"Lacca.Protocol.Const","doc":"","ref":"Lacca.Protocol.Const.html"},{"type":"function","title":"Lacca.Protocol.Const.handshake_rep/0","doc":"","ref":"Lacca.Protocol.Const.html#handshake_rep/0"},{"type":"function","title":"Lacca.Protocol.Const.handshake_req/0","doc":"","ref":"Lacca.Protocol.Const.html#handshake_req/0"},{"type":"function","title":"Lacca.Protocol.Const.start_process/0","doc":"","ref":"Lacca.Protocol.Const.html#start_process/0"},{"type":"function","title":"Lacca.Protocol.Const.stop_process/0","doc":"","ref":"Lacca.Protocol.Const.html#stop_process/0"},{"type":"function","title":"Lacca.Protocol.Const.version/0","doc":"","ref":"Lacca.Protocol.Const.html#version/0"},{"type":"module","title":"Lacca.Protocol.Encoder","doc":"This module provides helpers to encode messages suitable for being sent to a running a daemon which implements the shellac protocol. This module assumes that such a daemon is operating on a Port which has been started w/ the following options: [:binary, {:packet, 2}] .","ref":"Lacca.Protocol.Encoder.html"},{"type":"function","title":"Lacca.Protocol.Encoder.write_data_packet/1","doc":"","ref":"Lacca.Protocol.Encoder.html#write_data_packet/1"},{"type":"function","title":"Lacca.Protocol.Encoder.write_exit_packet/0","doc":"","ref":"Lacca.Protocol.Encoder.html#write_exit_packet/0"},{"type":"function","title":"Lacca.Protocol.Encoder.write_handshake_req/0","doc":"","ref":"Lacca.Protocol.Encoder.html#write_handshake_req/0"},{"type":"function","title":"Lacca.Protocol.Encoder.write_start_process/2","doc":"","ref":"Lacca.Protocol.Encoder.html#write_start_process/2"},{"type":"extras","title":"shellac","doc":"shellac shellac is a suite of software which aims to provides OS-level process control for the Elixir language. The software is composed of two sub-projects which coordinate to accomplish this goal: lacca : an Elixir process control library, implemented as an OTP application which can be included in a mix project. resin : a Rust binary which acts as a companion to the lacca OTP application. This binary provides process control and supervision, it also multiplexes the process's open file descriptors onto the single BEAM port.","ref":"readme.html"},{"type":"extras","title":"shellac - Prerequisites","doc":"You will need a Rust toolchain, which includes the build tool cargo , in order to sucesfully build this package. Please visit the Rust website for instructions on how to install these tools. This library can be built with the &quot;stable channel&quot; of the Rust compiler.","ref":"readme.html#prerequisites"},{"type":"extras","title":"shellac - Getting Started","doc":"Add {:lacca, &quot;~&gt; 0.2&quot;} to your mix.exs file's dependencies. Run mix deps.get to download the dependency. Run mix deps.compile to verify that the package compiles sucessfully. Use the library in your program, for instance ... { :ok , pid } = Lacca . start &quot;echo&quot; , [ &quot;hello, world.&quot; ] Lacca . read_stdout pid # {:ok, &quot;hello, world.\\n&quot;} Lacca . stop pid Note on Native Code This library builds a native executable which is bundled into the priv/ directory of this OTP application during the mix compile phase. To do this you must have a working Rust toolchain installed on any machine that will be compiling a project that depends on lacca . You do not need the toolchain installed on deployment targets, however when building a release, e.g: with the mix release command, you will need to ensure that the resulting binaries can be executed on the target system. Some common gotchas include: Building on Mac OS (mach) &amp; deploying on Linux (ELF), etc. Building on an x64 (64-bit) architecture and deploying on i686 (32-bit). On Windows: Rust has two toolchains, GNU and MSVC, so care should be taken to choose the correct one for your environment.","ref":"readme.html#getting-started"},{"type":"extras","title":"shellac - Protocol Versioning","doc":"Please note that this is alpha-quality software. There are plans to introduce backwards compatibility to the resin daemon at a later date; for example it would be possible to use a newer resin binary w/ an older lacca binary. However this functionality is not implemented in the prototype v0 . For best results it is strongly encouraged that you use matching versions of resin and lacca which were compiled together from the same sources. (This would be the default behavior if you are using mix to fetch your dependencies, as it will build resin from source for the current architecture.)","ref":"readme.html#protocol-versioning"},{"type":"extras","title":"shellac - Protocol Format","doc":"shellac v0 packets are sent on the wire as follows: (n) two bytes identifying packet length (data) packet specific data (n bytes, MsgPack encoded) Packet Types Packet types are as follows: TBD 1 . Start Process :: ( exec : string , args : [ string ] ] ) 2 . Kill Process :: ( ) 3 . DataOut :: ( ty : ( Stdout | Stderr ) , buf : [ u8 ] ) 4 . DataIn :: ( buf : [ u8 ] ) 5 . ExitStatus :: ( u32? ) 6 . ErrorReport :: ( string ) Future Additions POSIX signal support? Windows support? Standard stream redirection? Buffered input mode?","ref":"readme.html#protocol-format"},{"type":"extras","title":"shellac - Lacca Design","doc":"When the lacca application starts it will kick off a supervision process. To start an OS-level process lacca will perform the following initialization sequence: Start a child BEAM process w/ the given command line. Open a port to a resin daemon in :binary mode. Handshake w/ the resin daemon to verify matching protocol versions. Pass the initialization arguments to the resin daemon. Enter a message loop awaiting messages from the port, as well as messages from other peers in the Erlang VM.","ref":"readme.html#lacca-design"},{"type":"extras","title":"shellac - TODO","doc":"resin: general clean up of error handling what to do with errors if stdout goes away? logging facilities? resin: signal handling architecture need more generalized support for sending processes different kinds of signals, not just calling Child::kill() wtf do we do on Windows land? resin: restructure as state machine? there are bits of the server process state which don't exist until the inferior process is running. it would be nice if this was encoded in the type system as some kind of FSM so I can stop unwrapping Option&lt;..&gt; everywhere. resin: multi proc support Should one daemon be able to handle multiple inferior processes? I think this is what erlexec does but I'm not sure. Not sure this is actually desirable; reduces fault isolation, removes 1:1 mapping of erlang process -&gt; os process which makes it harder to structure OTP applications. there are arguments to be made about resource efficiency though (less vm ports/memory/CPU/file descriptors used, et al.) lacca: explore stdout/stderr API design space with streams how do we signal EOF? (separate packet type?) what if user wants to stream by line? should we send messages to interested processes instead of a buffer that is read-once? ( flush() destroys the contents of the buffer...) shellac: lightweight protocol once the protocol is relatively stable I'd like to design a custom wire format. we have pretty straightforward types (integer sizes, byte lists) and CBOR seems to have a fair bit of overhead since rust enums get encoded as dictionaries. this will be a major breaking change so probably do it before 1.0 shellac: error reporting internally resin has multiple threads coordinating to manage the process. this means that currently a request, and errors resulting from that request, happen asynchronously. for e.g: resin accepts input, passes input to the child, and then encounters an error. The lacca process would have already moved on, since it succesfully wrote the data to the port. only way I can see to fix this is to either enforce synchrony, or have the client provide a coorleation ID for errors. (basically tag each requests with a unique ID) that raises the question of what do we use for request IDs, how do we serialize it on the wire, is it part of packet header or packet itself? etc... port driver it may be interesting to use an actual port driver instead of starting a background daemon. see: https://erlang.org/doc/tutorial/c_portdriver.html a disadvantage of this is that resin becomes less useful from a calling context other than erlang.","ref":"readme.html#todo"}]